program demix;

uses dos;

const NUMSW = 8;
const SW_PRINT = 1;
      SW_ADD = 2;
      SW_MIX = 3;
      SW_CLIENT = 4;
      SW_ANGLES = 5;
      SW_SETVIEW = 6;
      SW_DAMAGE = 7;
      SW_REMOVE = 8;

var switch:array[1..NUMSW] of boolean;
    name:array[1..2] of string;
    p_start,p_end:array[1..2] of single;
    ec:word;
    enum:array[1..32] of word;
    trl:array[1..32] of word;

type header = record
                    len:longint;
                    a1,a2,a3:single;
              end;
     space = array[0..40000] of byte;

var mdlname:array[0..255] of string[40];
    m:array[0..1023] of record i:word; w:boolean; end;
    ue:array[0..1023] of boolean;

procedure dme_conv(file1,file2:string;ind:boolean);

var track:string;
    f,f2:file;
    ff1,ff2,ff3:file;
    b:space;
    b2:^space;
    hdr:header;
    i,j,k,p,dp,prior:word;
    entity:word;
    modelindex:byte;
    s:^word;
    time,ltime,xtime:single;
    mindiff:single;
    timed:boolean;
    newindex:word;
    l,l3:longint;
    l4,l5:longint;
    pass:boolean;
    maxspawn:word;
    renamed:boolean;
    copied:boolean;
    signonum:byte;
    viewent:word;
    stime:single;
    copied1,copied2:boolean;

procedure insert_entity(i:word);
begin
    ue[i]:=true;
    if b[0] and $01=0 then begin
       b[0]:=b[0] or $01;
       move(b[1],b[3],l);
       inc(l,2);
       b[1]:=$40;
    end else if b[1] and $40=0 then begin
       b[1]:=b[1] or $40;
       move(b[3],b[4],l);
       inc(l,1);
    end;
    move(i,b[2],2);
end;

label raushier,rauscd,rausangles;

begin
     assign(f,file1);     reset(f,1);
     assign(f2,file2);    rewrite(f2,1);
     if diskfree(0)<filesize(f) then begin
        writeln('demix: no space left on device');
        close(f);
        close(f2);
        exit;
     end;
     getmem(b2,40000);
     i:=0;
     repeat inc(i); blockread(f,track[i],1);
     until track[i]=#10;
     blockwrite(f2,track[1],i);
     time:=0;
     fillchar(m,sizeof(m),#0);
     if switch[SW_MIX] then begin
        assign(ff1,'tmp.##1'); if ind then reset(ff1,1) else rewrite(ff1,1);
        assign(ff2,'tmp.##2'); if ind then reset(ff2,1) else rewrite(ff2,1);
        assign(ff3,'tmp.##3'); if ind then reset(ff3,1) else rewrite(ff3,1);
     end;
     if switch[SW_CLIENT] then begin
        assign(ff1,'tmp.##1'); if ind then reset(ff1,1) else rewrite(ff1,1);
     end;
     if switch[SW_ANGLES] then begin
        assign(ff2,'tmp.##2'); if ind then reset(ff2,1) else rewrite(ff2,1);
     end;
     if switch[SW_DAMAGE] then begin
        assign(ff3,'tmp.##3'); if ind then reset(ff3,1) else rewrite(ff3,1);
        if ind then begin
           if eof(ff3) then stime:=1E6 else blockread(ff3,stime,4);
        end;
     end;
     copied:=false;
     copied1:=false;
     copied2:=false;
     maxspawn:=0;
     l4:=0; l5:=0;
     while not eof(f) do begin
           blockread(f,hdr,sizeof(hdr));
           blockread(f,b,hdr.len);
           fillchar(ue,sizeof(ue),#0);
           i:=0; dp:=0;
           signonum:=0;
           timed:=false;
           repeat
             prior:=i;
             copied:=false;
             case b[i] of
                $00: begin (* bad *)
                     end;
                $01: begin (* nop *)
                     end;
                $02: begin (* disconnect *)
                     end;
                $03: begin (* updatestat *)
                           inc(i,5);
                     end;
                $04: begin (* version *)
                           inc(i,4);
                     end;
                $05: begin (* setview *)
                           move(b[i+1],viewent,2);
                           if switch[SW_SETVIEW] and (time>=p_start[1])
                              and (time<p_end[1]) then copied:=true;
                           inc(i,2);
                     end;
                $06: begin (* sound *)
                           j:=b[i+1];
                           if (j and $1)<>0 then inc(i);
                           if (j and $2)<>0 then inc(i);
                           inc(i,10);
                     end;
                $07: begin (* time *)
                           move(b[i+1],time,4);
                           timed:=true;
                           inc(i,4);
                     end;
                $08: begin (* print *)
                           j:=i;
                           repeat inc(i) until b[i]=0;
                     end;
                $09: begin (* stufftext *)
                           repeat inc(i) until b[i]=0;
                     end;
                $0a: begin (* setangle *)
                           inc(i,3);
                     end;
                $0b: begin (* serverinfo *)
                           inc(i,6);
                           repeat inc(i) until b[i]=0;
                           newindex:=0;
                           repeat j:=i;
                                  inc(newindex);
                                  repeat inc(i) until b[i]=0;
                                  if i-j>1 then begin
                                     move(b[j+1],track[1],i-j-1);
                                     track[0]:=char(i-j-1);
                                     p:=pos('/',track);
                                     track:=copy(track,p+1,length(track)-p);
                                     p:=pos('.',track);
                                     if p<>0 then track:=copy(track,1,p-1);
                                     mdlname[newindex]:=track;
                                  end;
                           until i-j=1;
                           newindex:=0;
                           repeat j:=i;
                                  inc(newindex);
                                  repeat inc(i) until b[i]=0;
                           until i-j=1;
                     end;
                $0c: begin (* lightstyle *)
                           inc(i);
                           repeat inc(i) until b[i]=0;
                     end;
                $0d: begin (* updatename *)
                           inc(i);
                           repeat inc(i) until b[i]=0;
                     end;
                $0e: begin (* updatefrags *)
                           inc(i,3);
                     end;
                $0f: begin (* clientdata *)
                           if switch[SW_DAMAGE] and ind then
                              if (time>=p_start[2]) and (time<p_end[2]) then
                           begin
                              xtime:=p_start[1]+(time-p_start[2])*
                                   (p_end[1]-p_start[1])/(p_end[2]-p_start[2]);
                              if xtime>=stime then begin
                                 blockread(ff3,b2^[dp],9);
                                 if eof(ff3) then stime:=1E6
                                             else blockread(ff3,stime,4);
                                 inc(dp,9);
                              end;
                           end;
                           inc(i);
                           s:=@b[i];
                           inc(i,2);
                           if (s^ and $01)<>0 then inc(i);
                           if (s^ and $02)<>0 then inc(i);
                           if (s^ and $04)<>0 then inc(i);
                           if (s^ and $20)<>0 then inc(i);
                           if (s^ and $08)<>0 then inc(i);
                           if (s^ and $40)<>0 then inc(i);
                           if (s^ and $10)<>0 then inc(i);
                           if (s^ and $80)<>0 then inc(i);
                           inc(i,4);
                           if (s^ and $1000)<>0 then inc(i);
                           if (s^ and $2000)<>0 then inc(i);
                           if (s^ and $4000)<>0 then inc(i);
                           inc(i,7);
                           if switch[SW_CLIENT] then begin
                              if not ind then begin
                                 if (time>=p_start[1]) and (time<p_end[1]) then
                                 begin
                                      blockwrite(ff1,time,4);
                                      l:=i-prior+1;
                                      blockwrite(ff1,l,4);
                                      blockwrite(ff1,b[prior],l);
                                 end;
                              end else begin
                                 if (time>=p_start[2]) and (time<p_end[2]) then
                                 begin
                                      seek(ff1,l4);
                                      xtime:=p_start[1]+(time-p_start[2])*
                                             (p_end[1]-p_start[1])/
                                             (p_end[2]-p_start[2]);
                                      mindiff:=1E6;
                                      while not eof(ff1) do begin
                                            blockread(ff1,ltime,4);
                                            if abs(ltime-xtime)<=mindiff then
                                            begin
                                               mindiff:=abs(ltime-xtime);
                                               l4:=filepos(ff1)-4;
                                            end else begin
                                               goto rauscd;
                                            end;
                                            blockread(ff1,l,4);
                                            blockread(ff1,b2^[dp],l);
                                      end;
                                 rauscd:
                                      inc(dp,l);
                                      copied:=true;
                                 end;
                              end;
                           end;
                     end;
                $10: begin (* stopsound *)
                           inc(i,2);
                     end;
                $11: begin (* updatecolors *)
                           inc(i,2);
                     end;
                $12: begin (* particle *)
                           inc(i,11);
                     end;
                $13: begin (* damage *)
                           inc(i,8);
                           if switch[SW_DAMAGE] then begin
                              if not ind then begin
                                 if (time>=p_start[1]) and (time<p_end[1]) then
                                 begin
                                      blockwrite(ff3,time,4);
                                      blockwrite(ff3,b[prior],9);
                                 end;
                              end else begin
                                 if (time>=p_start[2]) and (time<p_end[2]) then
                                 begin
                                      copied:=true;
                                 end;
                              end;
                           end;
                     end;
                $14: begin (* spawnstatic *)
                           inc(i,13);
                     end;
                $15: begin (* spawnbinary *)
                     end;
                $16: begin (* spawnbaseline *)
                           move(b[i+1],k,2);
                           if not ind then for j:=1 to ec do
                              if (k=enum[j]) and (trl[j]<>0)
                              then begin
                                   move(b[prior],b2^[dp],16);
                                   inc(dp,16);
                                   k:=trl[j];
                                   move(k,b[i+1],2);
                              end;
                           m[k].i:=b[i+3];
                           if k>maxspawn then maxspawn:=k;
                           if switch[SW_MIX] and not ind then begin
                              pass:=(ec=0) and (m[k].i<>0);
                              for j:=1 to ec do
                                  if ((k=enum[j]) and (trl[j]=0))
                                  or ((k=trl[j]) and (trl[j]<>0))
                                  then pass:=true;
                              if pass then begin
                                 blockwrite(ff3,k,2);
                                 blockwrite(ff3,b[i],16);
                              end;
                           end;
                           inc(i,15);
                     end;
                $17: begin (* temp_entity *)
                           inc(i);
                           if (b[i]=5) or (b[i]=6) or (b[i]=9) or (b[i]=12)
                           then inc(i,14) else inc(i,6);
                     end;
                $18: begin (* setpause *)
                           inc(i);
                     end;
                $19: begin (* signon *)
                           inc(i);
                           signonum:=b[i];
                     end;
                $1a: begin (* centerprint *)
                           repeat inc(i) until b[i]=0;
                     end;
                $1b: begin (* killedmonster *)
                     end;
                $1c: begin (* foundsecret *)
                     end;
                $1d: begin (* spawnstaticsound *)
                           inc(i,9);
                     end;
                $1e: begin (* intermission *)
                     end;
                $1f: begin (* finale *)
                           repeat inc(i) until b[i]=0;
                     end;
                $20: begin (* cdtrack *)
                           inc(i,2);
                     end;
                $21: begin (* sellscreen *)
                     end;
                $22: begin (* cutscene *)
                           repeat inc(i) until b[i]=0;
                     end;
                $80..$ff:
                     begin (* updateentity *)
                           j:=b[i] and $7f;
                           if (j and $01)<>0 then begin
                              inc(i); j:=j or (b[i] shl 8);
                           end;
                           inc(i);
                           if (j and $4000)<>0 then begin
                              move(b[i],entity,2); inc(i);
                           end else begin
                              entity:=b[i];
                           end;
                           ue[entity]:=true;
                           if (time>=p_start[1]) and (time<p_end[1]) then
                              m[entity].w:=true;
                           modelindex:=0;
                           if (j and $0400)<>0 then begin
                              inc(i); modelindex:=b[i];
                              if (time>=p_start[1]) and (time<p_end[1]) then
                                 m[entity].i:=modelindex;
                           end;
                           if (j and $0040)<>0 then inc(i);
                           if (j and $0800)<>0 then inc(i);
                           if (j and $1000)<>0 then inc(i);
                           if (j and $2000)<>0 then inc(i);
                           if (j and $0002)<>0 then inc(i,2);
                           if (j and $0100)<>0 then inc(i);
                           if (j and $0004)<>0 then inc(i,2);
                           if (j and $0010)<>0 then inc(i);
                           if (j and $0008)<>0 then inc(i,2);
                           if (j and $0200)<>0 then inc(i);

                           if switch[SW_MIX] and timed and not ind
                              and (time>=p_start[1]) and (time<p_end[1])
                           then begin
                                l:=i-prior+1;
                                blockwrite(ff2,l,4);
                                blockwrite(ff2,entity,2);
                                blockwrite(ff2,b[prior],l);
                           end;

                           if switch[SW_REMOVE] and
                              (time>=p_start[1]) and (time<p_end[1])
                           then
                              for j:=1 to ec do
                                  if (entity=enum[j]) then copied:=true;

                           if switch[SW_ADD] and
                              (time>=p_start[1]) and (time<p_end[1])
                           then
                              for j:=1 to ec do
                                  if (entity=enum[j]) and (trl[j]<>0) then
                                  begin
                                       if b[prior] and $01=0 then begin
                                          b2^[dp]:=b[prior] or $01;
                                          b2^[dp+1]:=$40;
                                          inc(prior,2);
                                       end else if b[prior+1] and $40=0 then begin
                                          b2^[dp]:=b[prior];
                                          b2^[dp+1]:=b[prior+1] or $40;
                                          inc(prior,3);
                                       end else begin
                                          b2^[dp]:=b[prior];
                                          b2^[dp+1]:=b[prior+1];
                                          inc(prior,4);
                                       end;
                                       move(trl[j],b2^[dp+2],2);
                                       inc(dp,4);
                                  end;
                     end;
             end;
             inc(i);
             if not copied then begin
                move(b[prior],b2^[dp],i-prior);
                inc(dp,i-prior);
             end;
          until i>=hdr.len;
          if switch[SW_MIX] and ind and (signonum=2) then
             while not eof(ff3) do begin
                   blockread(ff3,k,2);
                   blockread(ff3,b2^[dp],16);
                   if m[k].i=0 then inc(dp,16);
             end;
          if switch[SW_ADD] and timed
             and (time>=p_start[1]) and (time<p_end[1])
          then
             for i:=1 to ec do if (not ue[enum[i]]) and (trl[i]=0) then
                 if enum[i]<256 then begin
                    b2^[dp]:=$80; b2^[dp+1]:=enum[i]; inc(dp,2);
                 end else begin
                    b2^[dp]:=$81; b2^[dp+1]:=$40;
                    b2^[dp+2]:=lo(enum[i]);
                    b2^[dp+3]:=hi(enum[i]);
                    inc(dp,4);
                 end;
          if switch[SW_MIX] and timed and not ind
             and (time>=p_start[1]) and (time<p_end[1])
          then begin
               blockwrite(ff1,time,4);
               l:=filepos(ff2)+4;
               blockwrite(ff1,l,4);
               l:=0;
               blockwrite(ff2,l,4);
          end;
          if switch[SW_MIX] and timed and ind
             and (time>=p_start[2]) and (time<p_end[2])
             and (signonum<>3)
          then begin
               seek(ff1,l4);
               time:=p_start[1]+(time-p_start[2])*(p_end[1]-p_start[1])/(p_end[2]-p_start[2]);
               mindiff:=1E6; l:=l5;
               while not eof(ff1) do begin
                     blockread(ff1,ltime,4);
                     if abs(ltime-time)<=mindiff then begin
                        mindiff:=abs(ltime-time);
                        l3:=l;
                     end else begin
                        l4:=filepos(ff1)-12;
                        l5:=l3;
                        goto raushier;
                     end;
                     blockread(ff1,l,4);
               end;
raushier:
               seek(ff2,l3);
               blockread(ff2,l,4);
               while l<>0 do begin
                     blockread(ff2,entity,2);
                     blockread(ff2,b,l);
                     renamed:=false;
                     for i:=1 to ec do if not renamed and (entity=enum[i]) then
                         if trl[i]<>0 then begin
                            entity:=trl[i];
                            renamed:=true;
                         end;
                     if (not ue[entity]) or (entity>maxspawn) then begin
                        pass:=ec=0;
                        if renamed then begin
                           for i:=1 to ec do if entity=trl[i] then pass:=true;
                        end else begin
                           for i:=1 to ec do if entity=enum[i] then pass:=true;
                        end;
                        if pass then begin
                           if renamed then
                              insert_entity(entity)
                           else if entity>maxspawn then
                              for i:=maxspawn+1 to 448 do if not ue[i]
                              then begin
                                   insert_entity(i);
                                   i:=448;
                              end;
                           move(b,b2^[dp],l);
                           inc(dp,l);
                        end;
                     end;
                     blockread(ff2,l,4);
               end;
          end;
          if switch[SW_ANGLES] then begin
             if not ind then begin
                if (time>=p_start[1]) and (time<p_end[1]) then
                begin
                     blockwrite(ff2,time,4);
                     blockwrite(ff2,hdr.a1,12);
                end;
             end else begin
                if (time>=p_start[2]) and (time<p_end[2]) then begin
                     seek(ff2,l5);
                     xtime:=p_start[1]+(time-p_start[2])*(p_end[1]-p_start[1])
                                                        /(p_end[2]-p_start[2]);
                     mindiff:=1E6;
                     while not eof(ff2) do begin
                           blockread(ff2,ltime,4);
                           if abs(ltime-xtime)<=mindiff then begin
                              mindiff:=abs(ltime-xtime);
                              l5:=filepos(ff2)-4;
                           end else begin
                              goto rausangles;
                           end;
                           blockread(ff2,hdr.a1,12);
                     end;
                rausangles:
                end;
             end;
          end;
          if switch[SW_SETVIEW] then begin
             if (time>=p_start[1]) and not copied1 then begin
                b2^[dp]:=$05;
                move(enum[1],b2^[dp+1],2);
                inc(dp,3);
                copied1:=true;
             end;
             if (time>=p_end[1]) and not copied2 then begin
                b2^[dp]:=$05;
                move(viewent,b2^[dp+1],2);
                inc(dp,3);
                copied2:=true;
             end;
          end;
          if (dp<>0) then begin
             hdr.len:=dp;
             blockwrite(f2,hdr,sizeof(hdr));
             blockwrite(f2,b2^,hdr.len);
          end;
     end;
     if switch[SW_PRINT] then
        for i:=0 to 1023 do
            if m[i].w then
               writeln('entity ',i:3,': ',mdlname[m[i].i]);
     close(f);
     l:=filesize(f2);
     close(f2);
     freemem(b2,40000);
     if switch[SW_MIX] then begin
        close(ff1); close(ff2); close(ff3);
        if ind then begin erase(ff1); erase(ff2); erase(ff3); end;
     end;
     if switch[SW_CLIENT] then begin
        close(ff1);
        if ind then erase(ff1);
     end;
     if switch[SW_ANGLES] then begin
        close(ff2);
        if ind then erase(ff2);
     end;
     if switch[SW_DAMAGE] then begin
        close(ff3);
        if ind then erase(ff3);
     end;
end;

procedure append_dem(var s:string);
var i:word;
    b:boolean;
begin
     b:=true;
     for i:=1 to length(s) do
         if s[i]='.' then b:=false
         else if s[i]='\' then b:=true;
     if b then s:=s+'.dem';
end;

procedure error;
begin
     writeln('demix: invalid arguments');
     halt;
end;

procedure parseargs;
var s,t:string;
    i:word;
    j,p:integer;
    nc,cc:word;
    sr:searchrec;
begin
     for i:=1 to NUMSW do switch[i]:=false;
     nc:=0; cc:=0; ec:=0;
     for i:=1 to paramcount do begin
         s:=paramstr(i);
         if s[1]='-' then begin
            for j:=2 to length(s) do case s[j] of
                'c': switch[SW_CLIENT]:=true;
                'a': switch[SW_ANGLES]:=true;
                'v': switch[SW_SETVIEW]:=true;
                'd': switch[SW_DAMAGE]:=true;
                'r': switch[SW_REMOVE]:=true;
                else begin
                     writeln('demix: unsupported switch -',s[j]);
                     halt;
                end;
            end;
         end else if (s[1]>='0') and (s[1]<='9') or (s[1]=':') then begin
            p:=pos(':',s);
            if p=0 then begin
                inc(ec);
                p:=pos('-',s);
                if p=0 then begin
                   val(s,enum[ec],j);
                   trl[ec]:=0;
                end else begin
                   val(copy(s,1,p-1),enum[ec],j);
                   val(copy(s,p+1,length(s)-p),trl[ec],j);
                end;
            end else begin
                inc(cc); if cc>=3 then error;
                if p<>1 then val(copy(s,1,p-1),p_start[cc],j)
                else p_start[cc]:=0;
                if p<>length(s) then val(copy(s,p+1,length(s)-p),p_end[cc],j)
                else p_end[cc]:=1E6;
            end;
         end else begin
            inc(nc); if nc>=3 then error;
            append_dem(s);
            name[nc]:=s;
         end;
     end;
     if nc<>cc then error;
     if cc=0 then error;
     switch[SW_PRINT]:=(cc=1) and (ec=0);
     switch[SW_ADD]:=(cc=1) and (ec>0) and not switch[SW_SETVIEW]
                                       and not switch[SW_REMOVE];
     switch[SW_MIX]:=(cc=2) and not
           (switch[SW_CLIENT] or switch[SW_ANGLES] or switch[SW_DAMAGE]);
     if (switch[SW_CLIENT] or switch[SW_ANGLES] or switch[SW_DAMAGE])
        and (cc<>2) and (ec<>0) then error;
     if switch[SW_SETVIEW] and switch[SW_REMOVE] then error;
     if switch[SW_SETVIEW] and ((cc<>1) or (ec<>1)) then error;
     if switch[SW_REMOVE] and ((cc<>1) or (ec=0)) then error;
     if cc=2 then begin
        if p_end[1]=1E6 then p_end[1]:=p_start[1]+p_end[2]-p_start[2];
        if p_end[2]=1E6 then p_end[2]:=p_start[2]+p_end[1]-p_start[1];
     end;
end;

procedure find(var s:string);
var num,i:word;
    t:string;
    sr:searchrec;
begin
     num:=0;
     t:=s;
     findfirst(s,archive,sr);
     while doserror=0 do begin
           inc(num);
           s:=sr.name;
           findnext(sr);
     end;
     if num<>1 then begin
        writeln('demix: ',t,' not found');
        halt;
     end;
     num:=0;
     for i:=1 to length(t) do if t[i]='\' then num:=i;
     t[0]:=chr(num);
     s:=t+s;
end;

procedure usage;
begin
     writeln('demix: demo entity manipulation utility');
     writeln;
     writeln('demix <demo1> <from:to>');
     writeln('      output description for all entities occuring in given range');
     writeln('demix <demo1> <from:to> <entity1> ... <entityn>');
     writeln('      add updateentity messages for given entities in specified range');
     writeln('demix <demo1> <from:to> <demo2> <from:to> [entity1 ... entityn]');
     writeln('      add parts from demo1 to demo2 [only for these entity numbers]');
     writeln('demix -c <demo1> <from:to> <demo2> <from:to>');
     writeln('      copy clientdata from demo1 to demo2 in given range');
     writeln('demix -a <demo1> <from:to> <demo2> <from:to>');
     writeln('      copy angles from demo1 to demo2 in given range');
     writeln('demix -d <demo1> <from:to> <demo2> <from:to>');
     writeln('      replace damage messages in demo2 with those from demo1');
     writeln('demix -v <entity> <demo1> <from:to>');
     writeln('      give the setview to entity at ''from'' and restore it at ''to''');
     writeln('demix -r <demo1> <from:to> <entity1> ... <entityn>');
     writeln('      remove updateentity messages for given entities in specified range');
     halt;
end;

var f:file;
begin
     if paramcount=0 then usage;
     parseargs;
     find(name[1]);
     if switch[SW_MIX] then find(name[2]);
     dme_conv(name[1],'tmp.$$$',false);
     if switch[SW_MIX] or switch[SW_CLIENT] or switch[SW_ANGLES]
                       or switch[SW_DAMAGE] then
     begin
        dme_conv(name[2],'tmp.$$$',true);
        assign(f,name[2]);   erase(f);
        assign(f,'tmp.$$$'); rename(f,name[2]);
     end else if switch[SW_ADD] or switch[SW_SETVIEW] or switch[SW_REMOVE]
     then begin
        assign(f,name[1]);   erase(f);
        assign(f,'tmp.$$$'); rename(f,name[1]);
     end else begin
        assign(f,'tmp.$$$'); erase(f);
     end;
end.
